# fiftyten-service-contracts
Common API contracts for FiftyTen microservices

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.0.3
- Generator version: 7.13.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import fiftyten_service_contracts
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import fiftyten_service_contracts
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import fiftyten_service_contracts
from fiftyten_service_contracts.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost:3030
# See configuration.py for a list of all supported configuration parameters.
configuration = fiftyten_service_contracts.Configuration(
    host = "http://localhost:3030"
)



# Enter a context with an instance of the API client
with fiftyten_service_contracts.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = fiftyten_service_contracts.DefaultApi(api_client)

    try:
        # Health check
        api_response = api_instance.api_health_get()
        print("The response of DefaultApi->api_health_get:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->api_health_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:3030*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**api_health_get**](docs/DefaultApi.md#api_health_get) | **GET** /api/health | Health check
*DefaultApi* | [**api_tasks_post**](docs/DefaultApi.md#api_tasks_post) | **POST** /api/tasks | Submit tasks (single or batch)
*DefaultApi* | [**api_workers_heartbeat_post**](docs/DefaultApi.md#api_workers_heartbeat_post) | **POST** /api/workers/heartbeat | Send worker heartbeat
*DefaultApi* | [**api_workers_register_post**](docs/DefaultApi.md#api_workers_register_post) | **POST** /api/workers/register | Register a worker
*DefaultApi* | [**api_workers_task_result_post**](docs/DefaultApi.md#api_workers_task_result_post) | **POST** /api/workers/task-result | Submit task result


## Documentation For Models

 - [ApiHealthGet200Response](docs/ApiHealthGet200Response.md)
 - [ApiTasksPostRequest](docs/ApiTasksPostRequest.md)
 - [ApiTasksPostRequestOneOf](docs/ApiTasksPostRequestOneOf.md)
 - [BaseMarketContext](docs/BaseMarketContext.md)
 - [Candle](docs/Candle.md)
 - [CandleStore](docs/CandleStore.md)
 - [CryptoMarketContext](docs/CryptoMarketContext.md)
 - [CryptoMarketType](docs/CryptoMarketType.md)
 - [DataUpdateEvent](docs/DataUpdateEvent.md)
 - [DataUpdateEventContext](docs/DataUpdateEventContext.md)
 - [EventMetadata](docs/EventMetadata.md)
 - [ExchangeType](docs/ExchangeType.md)
 - [Interval](docs/Interval.md)
 - [LoadContext](docs/LoadContext.md)
 - [Symbol](docs/Symbol.md)
 - [Task](docs/Task.md)
 - [TaskResult](docs/TaskResult.md)
 - [WorkerRegistration](docs/WorkerRegistration.md)
 - [WorkerStatus](docs/WorkerStatus.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




